extern "C" {
#include "caida_t.h"
}

#ifndef _ARTSABSTRACT_H_
#define _ARTSABSTRACT_H_

#include <vector>
#include "ArtsHeader.hh"
#include "ArtsAttribute.hh"

class ArtsAbstract 
{
public:
  //------------------------------------------------------------------------
  //                     inline ArtsHeader & Header()
  //------------------------------------------------------------------------
  inline ArtsHeader & Header()
  {
    return(this->_header);
  }

  //------------------------------------------------------------------------
  //              inline vector<ArtsAttribute> & Attributes()
  //------------------------------------------------------------------------
  inline vector<ArtsAttribute> & Attributes()
  {
    return(this->_attributes);
  }

  inline ArtsIpPathData & Path()
  {
    return(*(this->_data._ipPath));
  }
  
  ArtsHeader              _header;
  vector<ArtsAttribute>   _attributes;
private:
  union {
    ArtsIpPathData* _ipPath;
  } _data;
};

#endif  /*  _ARTSABSTRACT_H_  */
